/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Directive, ElementRef, Input } from '@angular/core';
import { EsriMapService } from './../../core/esri-map.service';
export class CustomWidgetDirective {
    /**
     * @param {?} el
     * @param {?} mapService
     */
    constructor(el, mapService) {
        this.el = el;
        this.mapService = mapService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.mapService.isLoaded.subscribe(() => {
            // after map is loaded then add widget
            this.mapService.addWidget(this.el.nativeElement, this.position);
        });
    }
}
CustomWidgetDirective.decorators = [
    { type: Directive, args: [{
                selector: '[esriCustomWidget], [esri-customWidget]'
            },] },
];
/** @nocollapse */
CustomWidgetDirective.ctorParameters = () => [
    { type: ElementRef, },
    { type: EsriMapService, },
];
CustomWidgetDirective.propDecorators = {
    "position": [{ type: Input },],
};
function CustomWidgetDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    CustomWidgetDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    CustomWidgetDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    CustomWidgetDirective.propDecorators;
    /** @type {?} */
    CustomWidgetDirective.prototype.position;
    /** @type {?} */
    CustomWidgetDirective.prototype.el;
    /** @type {?} */
    CustomWidgetDirective.prototype.mapService;
}
//# sourceMappingURL=custom-widget.directive.js.map
