/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input } from '@angular/core';
import { EsriMapService } from '../../core/esri-map.service';
export class LayersToggleComponent {
    /**
     * @param {?} mapService
     */
    constructor(mapService) {
        this.mapService = mapService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.mapService.isLoaded.subscribe(() => {
            this.map = this.mapService.map;
            this.view = this.mapService.view;
        });
    }
    /**
     * @param {?} $event
     * @param {?} layer
     * @return {?}
     */
    onCheck($event, layer) {
        layer.visible = $event.target.checked;
    }
    /**
     * @param {?} layer
     * @return {?}
     */
    onZoomLayer(layer) {
        if (this.view.type === '2d') {
            (/** @type {?} */ (this.view)).goTo(layer.fullExtent);
        }
        else {
            const /** @type {?} */ sceneView = /** @type {?} */ (this.view);
            sceneView.goTo({
                target: layer.fullExtent,
                heading: sceneView.camera.heading
            });
        }
    }
}
LayersToggleComponent.decorators = [
    { type: Component, args: [{
                selector: 'esri-layers-toggle, esri-layersToggle',
                template: `<div esriCustomWidget [position]="position">
  <!-- Only display if there is a map and it has layers -->
  <div *ngIf="map?.layers.length > 0" class="esri-layers-toggle">
    <div *ngFor="let layer of map.layers.toArray()">
      <input type="checkbox" [checked]="layer.visible" (click)="onCheck($event, layer)" /> {{layer.title}}
      <a href="javascript:void(0)" (click)="onZoomLayer(layer)">Zoom</a>
      <esri-sublayers-toggle [layer]="layer" *ngIf="layer.sublayers && layer.sublayers.items"></esri-sublayers-toggle>
    </div>
  </div>
</div>`,
                styles: [`.esri-layers-toggle{z-index:99;background-color:#fff;border-radius:8px;padding:10px;opacity:.75}`]
            },] },
];
/** @nocollapse */
LayersToggleComponent.ctorParameters = () => [
    { type: EsriMapService, },
];
LayersToggleComponent.propDecorators = {
    "position": [{ type: Input },],
};
function LayersToggleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    LayersToggleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    LayersToggleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    LayersToggleComponent.propDecorators;
    /** @type {?} */
    LayersToggleComponent.prototype.map;
    /** @type {?} */
    LayersToggleComponent.prototype.view;
    /** @type {?} */
    LayersToggleComponent.prototype.position;
    /** @type {?} */
    LayersToggleComponent.prototype.mapService;
}
//# sourceMappingURL=layers-toggle.component.js.map
