/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input } from '@angular/core';
export class SubLayersToggleComponent {
    constructor() { }
    /**
     * @param {?} layer
     * @return {?}
     */
    set layer(layer) {
        this._sublayers = layer.sublayers
            .toArray()
            .slice()
            .reverse();
    }
    /**
     * @param {?} $event
     * @param {?} sublayer
     * @return {?}
     */
    onCheck($event, sublayer) {
        sublayer.visible = $event.target.checked;
    }
}
SubLayersToggleComponent.decorators = [
    { type: Component, args: [{
                selector: 'esri-sublayers-toggle, esri-sublayersToggle',
                template: `<div *ngFor="let sublayer of _sublayers" class="sublayers">
  <input type="checkbox" [checked]="sublayer.visible" (click)="onCheck($event, sublayer)" /> {{sublayer.title}}
  <esri-sublayers-toggle [layer]="sublayer" *ngIf="sublayer.sublayers && sublayer.sublayers.toArray()"></esri-sublayers-toggle><!--recursive sub layers-->
</div>
`,
                styles: [`.sublayers{padding-left:15px}`]
            },] },
];
/** @nocollapse */
SubLayersToggleComponent.ctorParameters = () => [];
SubLayersToggleComponent.propDecorators = {
    "layer": [{ type: Input },],
};
function SubLayersToggleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    SubLayersToggleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    SubLayersToggleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    SubLayersToggleComponent.propDecorators;
    /** @type {?} */
    SubLayersToggleComponent.prototype._sublayers;
}
//# sourceMappingURL=sub-layers-toggle.component.js.map
