import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Injectable, EventEmitter } from '@angular/core';
import { EsriModuleProvider } from './esri-module-provider';
var EsriMapService = /** @class */ (function () {
    /**
     * @param {?} moduleProvider
     */
    function EsriMapService(moduleProvider) {
        this.moduleProvider = moduleProvider;
        this.isLoaded = new EventEmitter();
    }
    /**
     * @param {?} mapViewProperties
     * @param {?} mapEl
     * @param {?} map
     * @return {?}
     */
    EsriMapService.prototype.prepareViewProps = function (mapViewProperties, mapEl, map) {
        var /** @type {?} */ newViewProps = this.extend({}, mapViewProperties);
        if (!newViewProps.container) {
            newViewProps.container = mapEl.nativeElement.id;
        }
        if (!newViewProps.map) {
            newViewProps.map = map;
        }
        return newViewProps;
    };
    /**
     * @param {?} mapProperties
     * @param {?} viewProperties
     * @param {?} mapEl
     * @param {?=} viewType
     * @return {?}
     */
    EsriMapService.prototype.loadMap = function (mapProperties, viewProperties, mapEl, viewType) {
        var _this = this;
        if (viewType === void 0) { viewType = 'MapView'; }
        return this.moduleProvider
            .require(['esri/Map', 'esri/views/' + viewType])
            .then(function (_a) {
            var _b = tslib_1.__read(_a, 2), Map = _b[0], View = _b[1];
            // create map
            var /** @type {?} */ map = new Map(mapProperties);
            // prepare properties that should be set locally
            // create a new object so as to not modify the provided object
            var /** @type {?} */ newViewProps = _this.prepareViewProps(viewProperties, mapEl, map);
            // create the MapView
            var /** @type {?} */ view = new View(newViewProps);
            _this.map = map;
            _this.view = view;
            _this.isLoaded.emit();
            return {
                map: map,
                view: view
            };
        });
    };
    /**
     * @param {?} webMapProperties
     * @param {?} viewProperties
     * @param {?} mapEl
     * @param {?=} viewType
     * @return {?}
     */
    EsriMapService.prototype.loadWebMap = function (webMapProperties, viewProperties, mapEl, viewType) {
        var _this = this;
        if (viewType === void 0) { viewType = 'MapView'; }
        return this.moduleProvider
            .require(['esri/WebMap', 'esri/views/' + viewType])
            .then(function (_a) {
            var _b = tslib_1.__read(_a, 2), WebMap = _b[0], View = _b[1];
            // create map
            var /** @type {?} */ map = new WebMap(webMapProperties);
            // prepare properties that should be set locally
            // create a new object so as to not modify the provided object
            var /** @type {?} */ newViewProps = _this.prepareViewProps(viewProperties, mapEl, map);
            // create the MapView
            var /** @type {?} */ view = new View(newViewProps);
            _this.map = map;
            _this.view = view;
            _this.isLoaded.emit();
            return {
                map: map,
                view: view
            };
        });
    };
    /**
     * @param {?} element
     * @param {?} position
     * @return {?}
     */
    EsriMapService.prototype.addWidget = function (element, position) {
        this.view.ui.add(element, position);
    };
    /**
     * @param {?} obj
     * @param {?} src
     * @return {?}
     */
    EsriMapService.prototype.extend = function (obj, src) {
        Object.keys(src).forEach(function (key) {
            obj[key] = src[key];
        });
        return obj;
    };
    return EsriMapService;
}());
export { EsriMapService };
EsriMapService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
EsriMapService.ctorParameters = function () { return [
    { type: EsriModuleProvider, },
]; };
function EsriMapService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    EsriMapService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    EsriMapService.ctorParameters;
    /** @type {?} */
    EsriMapService.prototype.isLoaded;
    /** @type {?} */
    EsriMapService.prototype.map;
    /** @type {?} */
    EsriMapService.prototype.view;
    /** @type {?} */
    EsriMapService.prototype.moduleProvider;
}
//# sourceMappingURL=esri-map.service.js.map
