/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input } from '@angular/core';
import { EsriMapService } from '../../core/esri-map.service';
var LayersToggleComponent = /** @class */ (function () {
    /**
     * @param {?} mapService
     */
    function LayersToggleComponent(mapService) {
        this.mapService = mapService;
    }
    /**
     * @return {?}
     */
    LayersToggleComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.mapService.isLoaded.subscribe(function () {
            _this.map = _this.mapService.map;
            _this.view = _this.mapService.view;
        });
    };
    /**
     * @param {?} $event
     * @param {?} layer
     * @return {?}
     */
    LayersToggleComponent.prototype.onCheck = function ($event, layer) {
        layer.visible = $event.target.checked;
    };
    /**
     * @param {?} layer
     * @return {?}
     */
    LayersToggleComponent.prototype.onZoomLayer = function (layer) {
        if (this.view.type === '2d') {
            ((this.view)).goTo(layer.fullExtent);
        }
        else {
            var /** @type {?} */ sceneView = (this.view);
            sceneView.goTo({
                target: layer.fullExtent,
                heading: sceneView.camera.heading
            });
        }
    };
    return LayersToggleComponent;
}());
export { LayersToggleComponent };
LayersToggleComponent.decorators = [
    { type: Component, args: [{
                selector: 'esri-layers-toggle, esri-layersToggle',
                template: "<div esriCustomWidget [position]=\"position\">\n  <!-- Only display if there is a map and it has layers -->\n  <div *ngIf=\"map?.layers.length > 0\" class=\"esri-layers-toggle\">\n    <div *ngFor=\"let layer of map.layers.toArray()\">\n      <input type=\"checkbox\" [checked]=\"layer.visible\" (click)=\"onCheck($event, layer)\" /> {{layer.title}}\n      <a href=\"javascript:void(0)\" (click)=\"onZoomLayer(layer)\">Zoom</a>\n      <esri-sublayers-toggle [layer]=\"layer\" *ngIf=\"layer.sublayers && layer.sublayers.items\"></esri-sublayers-toggle>\n    </div>\n  </div>\n</div>",
                styles: [".esri-layers-toggle{z-index:99;background-color:#fff;border-radius:8px;padding:10px;opacity:.75}"]
            },] },
];
/** @nocollapse */
LayersToggleComponent.ctorParameters = function () { return [
    { type: EsriMapService, },
]; };
LayersToggleComponent.propDecorators = {
    "position": [{ type: Input },],
};
function LayersToggleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    LayersToggleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    LayersToggleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    LayersToggleComponent.propDecorators;
    /** @type {?} */
    LayersToggleComponent.prototype.map;
    /** @type {?} */
    LayersToggleComponent.prototype.view;
    /** @type {?} */
    LayersToggleComponent.prototype.position;
    /** @type {?} */
    LayersToggleComponent.prototype.mapService;
}
//# sourceMappingURL=layers-toggle.component.js.map
