/// <reference types="arcgis-js-api" />
import { ElementRef, EventEmitter } from '@angular/core';
import { EsriModuleProvider } from './esri-module-provider';
export declare class EsriMapService {
    private moduleProvider;
    isLoaded: EventEmitter<{}>;
    map: __esri.Map;
    view: __esri.View;
    constructor(moduleProvider: EsriModuleProvider);
    prepareViewProps(mapViewProperties: __esri.ViewProperties, mapEl: ElementRef, map: __esri.Map): __esri.ViewProperties;
    loadMap(mapProperties: __esri.MapProperties, viewProperties: __esri.ViewProperties, mapEl: ElementRef, viewType?: string): Promise<{
        map: __esri.Map;
        view: __esri.View;
    }>;
    loadWebMap(webMapProperties: __esri.WebMapProperties, viewProperties: __esri.ViewProperties, mapEl: ElementRef, viewType?: string): Promise<{
        map: __esri.WebMap;
        view: __esri.View;
    }>;
    addWidget(element: HTMLElement, position: string): void;
    extend(obj: __esri.ViewProperties, src: __esri.ViewProperties): __esri.ViewProperties;
}
